/*Ŀ
                             DMOTASK.PRG                                  
  */
# include "gemini.ch"

STATIC ClockTask
STATIC BackTask
STATIC NumSpool := 0

MEMVAR oFileMnu, oFileStu, oFileEdi, oFileSoft
/**/
FUNCTION DEMO_TMOUT( oMenu )

if( oMenu:CheckSum[ oMenu:Choice ] )
   SetTimeOut( 15, { || DEMO_TMBLK() } )
else
   ClearTimeOut()
endif
Return ( nil )
/**/
FUNCTION DEMO_TMBLK()

LOCAL oWin

SaveCursor()

oWin := WinNew()
   oWin:Top    := 11
   oWin:Bottom := 13
   oWin:Left   := 20
   oWin:Right  := 60
   oWin:Shadow := .T.
   oWin:Color  := "W+/R"
   oWin:Grow   := .T.
   oWin:Configure()
   oWin:Display()
   oWin:ScrollText( 0, "No event since 15 seconds...", 80 )

oWin:Close()
RestCursor()

Return ( nil )
/**/
FUNCTION DEMO_BTASK( oMenu )

LOCAL oPrinter
LOCAL oFileStu
LOCAL Add
LOCAL oDlg

oDlg       := DialogNew()
oDlg:Title := "INFO"

if( oMenu:CheckSum[ oMenu:Choice ] )

   Add  := .T.
   oPrinter          := PrinterNew()
   oPrinter:Number   := 1
   oPrinter:NumLines := 50
   oPrinter:Cargo    := oMenu
   oPrinter:File( "SCORES" )

   BackTask       := TaskNew()
   BackTask:Name  := "BACK"
   BackTask:Block := { || DEMO_BBLK( oPrinter ) }

   oDlg:AddLine( "BackGround Task activated" )
   oDlg:AddLine( "Computing the mean of students scores" )
   oDlg:AddLine( "( File Students.dbf )" )
else
    Add := .F.
    oDlg:AddLine( "BackGround Task deactivated")
endif

oDlg:Configure()
SaveCursor()
oDlg:Activate()
RestCursor()
oDlg:Kill()

if( Add )
   BackTask:BTaskPush()
else
   BTaskRemove( "BACK" )
endif

Return ( nil )
/**/
FUNCTION DEMO_BBLK( oPrinter )

LOCAL Mean := 0
LOCAL oDial

if( (oFileStu:Area)->( Eof() ) )

   (oFileStu:Area)->( DbGotop() )
   oPrinter:Close()

   BTaskPause()
   MSE_HIDE()
   SaveCursor()

   oDial := DialogNew()
   oDial:AddLine( "Background Task over" )
   oDial:Additem( DLG_OK )
   oDial:Configure()
   oDial:Activate()
   oDial:Kill()

   BTaskContinue()
   RestCursor()
   MSE_SHOW()

   oPrinter:Cargo:CheckSum[3] := .F. 
   Return ( .T. )

endif

if( oPrinter:Row > oPrinter:NumLines )
   oPrinter:FormFeed()
endif

Mean := ( (oFileStu:Area)->STU_JAN + (oFileStu:Area)->STU_FEB + ;
          (oFileStu:Area)->STU_MAR + (oFileStu:Area)->STU_APR + ;
          (oFileStu:Area)->STU_MAY + (oFileStu:Area)->STU_JUN + ;
          (oFileStu:Area)->STU_JUL + (oFileStu:Area)->STU_AUG + ;
          (oFileStu:Area)->STU_SEP + (oFileStu:Area)->STU_OCT + ;
          (oFileStu:Area)->STU_NOV + (oFileStu:Area)->STU_DEC ) / 12

oPrinter:Write( (oFileStu:Area)->STU_NAME          + ;
                (oFileStu:Area)->STU_FIRST         + ;
                str( (oFileStu:Area)->STU_JAN, 3 ) + ;
                str( (oFileStu:Area)->STU_FEB, 3 ) + ;
                str( (oFileStu:Area)->STU_MAR, 3 ) + ;
                str( (oFileStu:Area)->STU_APR, 3 ) + ;
                str( (oFileStu:Area)->STU_MAY, 3 ) + ;
                str( (oFileStu:Area)->STU_JUN, 3 ) + ;
                str( (oFileStu:Area)->STU_JUL, 3 ) + ;
                str( (oFileStu:Area)->STU_AUG, 3 ) + ;
                str( (oFileStu:Area)->STU_SEP, 3 ) + ;
                str( (oFileStu:Area)->STU_OCT, 3 ) + ;
                str( (oFileStu:Area)->STU_NOV, 3 ) + ;
                str( (oFileStu:Area)->STU_DEC, 3 ) + Str( Mean,6,2) )

oPrinter:NextLine()
(oFileStu:Area)->( Dbskip( 1 ) )

Return( .F. )
/**/
FUNCTION DEMO_CTASK( oMenu )

LOCAL Task
LOCAL Add
LOCAL oDlg 

oDlg       := DialogNew()
oDlg:Title := "INFO"

if( oMenu:CheckSum[ oMenu:Choice ] )

    Add        := .T.
    Task       := TaskNew() 
    Task:Name  := "CLOCK"
    Task:Data  := oMenu     
    Task:Block := {|o| DEMO_CBLK(o) }

    oDlg:AddLine( "Clock Task will be activated within 15 secondes" )
    oDlg:AddLine( "( Files reindexing )" )
else
    Add := .F.
    oDlg:AddLine( "Clock Task deactivated")
endif

oDlg:Configure()
SaveCursor()
oDlg:Activate()
RestCursor()
oDlg:Kill()

if( Add )
    Task:Time  := StoT( seconds() + 15 )
    Task:CTaskPush()
else
    CTaskRemove( "CLOCK" )
endif

Return( nil )
/**/
FUNCTION DEMO_CBLK( oMenu )

LOCAL oDlg, NumRec, Cursor, CursRow, CursCol
LOCAL oGauge := GaugeNew()
      oGauge:Color     := "R/W,GR+/R"
      oGauge:Top       := 10
      oGauge:Left      := 10
      oGauge:Bottom    := 13
      oGauge:Right     := 69
      oGauge:Title     := "Files Reindexing"
      oGauge:Line      :=  1
      oGauge:HighValue :=  8
      oGauge:Configure()

MSE_HIDE()
SaveCursor()
oGauge:Display()

oGauge:Window:Say(0,1,"Indexing " +oFileMnu:Name+ Space(10) )

NumRec := (oFileMnu:Area)->(Recno())
(oFileMnu:Area)->(DbReindex())
(oFileMnu:Area)->(DbGoto(NumRec))

WaitMsec(1000)
oGauge:Update(2)
TaskVerify()

oGauge:Window:Say(0,1,"Indexing " +oFileEdi:Name+ Space(10) )

NumRec := (oFileEdi:Area)->(Recno())
(oFileEdi:Area)->(DbReindex())
(oFileEdi:Area)->(DbGoto(NumRec))

WaitMsec(1000)
oGauge:Update(3)
TaskVerify()

oGauge:Window:Say(0,1,"Indexing " +oFileSoft:Name+ Space(10) )

NumRec := (oFileSoft:Area)->(Recno())
(oFileSoft:Area)->(DbReindex())
(oFileSoft:Area)->(DbGoto(NumRec))

WaitMsec(1000)
oGauge:Update(2)
TaskVerify()

oGauge:Window:Say(0,1,"Indexing " +oFileStu:Name+ Space(10) )

NumRec := (oFileStu:Area)->(Recno())
(oFileStu:Area)->(DbReindex())
(oFileSoft:Area)->(DbGoto(NumRec))

WaitMsec(1000)
oGauge:Update(1)
TaskVerify()

oDlg := DialogNew()
    oDlg:Title := "Info"
    oDlg:AddLine( "Clock Task over" )
    oDlg:AddItem( DLG_OK )
    oDlg:Configure()
    oDlg:Activate()
    oDlg:Kill()

oGauge:Close()
RestCursor()
oMenu:CheckSum[2] := .F.

Return( nil )
/**/
FUNCTION DEMO_SPOOL( oMenu )

LOCAL oPrinter := PrinterNew()
LOCAL oSpool   := SpoolNew()
LOCAL oDlg

SaveCursor()
oDlg := DialogNew()
    oDlg:Title   := "INFO"
    oDlg:Justify := CENTERJUSTIFY
    oDlg:AddLine( "Printing file DMOBRWF.PRG" )
    oDlg:AddItem( "Oui" )
    oDlg:AddItem( "Non" )
    oDlg:Configure()

if( oDlg:Activate() == 2 )
    RestCursor()
    Return( nil )
endif

oPrinter:Number   := 1
oPrinter:Numlines := 64

oSpool:Printer  := oPrinter
oSpool:FName    := "DMOBRWF.PRG"
oSpool:Block    := {|oSpool| DEMO_SPLBLK(oSpool) }
oSpool:Delete   := .F.
oSpool:SpoolPush()

Return( nil )
/**/
FUNCTION DEMO_SPLBLK( oSpool )

LOCAL oDlg

if( oSpool:Pourcent == 100 )
    MSE_HIDE()
    SaveCursor()
    oDlg := DialogNew()
        oDlg:Title := "INFO"
        oDlg:AddLine( "Printing Task over" )
        oDlg:AddItem( DLG_OK )
        oDlg:Configure()
        oDlg:Activate()
    RestCursor()
    MSE_SHOW()
endif
Return( nil )
/**/
