/*Ŀ
   DEFINE FOR BOX   
  */

// Single-line box
#define	B_SINGLE 	( CHR(218) + CHR(196) + CHR(191) + CHR(179) + ;
                      CHR(217) + CHR(196) + CHR(192) + CHR(179) + " " )

// Single-inter-line box
#define	B_SINGLE_INTER	( CHR(195) + CHR(180) + CHR(194) + CHR(193) + ;
                          CHR(197)  )

// Double-line box
#define B_DOUBLE	( CHR(201) + CHR(205) + CHR(187) + CHR(186) + ;
                      CHR(188) + CHR(205) + CHR(200) + CHR(186) + " ")

#define B_DOUBLE_FULL ( CHR(201) + CHR(205) + CHR(187) + CHR(186) + ;
                        CHR(188) + CHR(205) + CHR(200) + CHR(186) + CHR(176) )

#define B_THIN  (CHR(204)+CHR(206)+CHR(207)+CHR(208)+CHR(209)+CHR(210)+CHR(211)+CHR(212)+" ")

#define DLG_YES            "\Y"
#define DLG_NO             "\N"
#define DLG_CANCEL         "\C"
#define DLG_OK             "\O"
#define DLG_YESNO          "\YN"
#define DLG_YESNOCANCEL    "\YNC"

/*Ŀ
   COMMAND TOOLS  
  */

#translate ISNIL( <v1> )                => ( <v1> == NIL )
#translate ISARRAY( <v1> )              => ( valtype( <v1> ) == "A" )
#translate ISBLOCK( <v1> )              => ( valtype( <v1> ) == "B" )
#translate ISCHARACTER( <v1> )          => ( valtype( <v1> ) == "C" )
#translate ISDATE( <v1> )               => ( valtype( <v1> ) == "D" )
#translate ISLOGICAL( <v1> )            => ( valtype( <v1> ) == "L" )
#translate ISMEMO( <v1> )               => ( valtype( <v1> ) == "M" )
#translate ISNUMBER( <v1> )             => ( valtype( <v1> ) == "N" )
#translate ISOBJECT( <v1> )             => ( valtype( <v1> ) == "O" )
#translate ISBETWEEN( <var>,<v1>,<v2> ) => ( if( <var> >= <v1> .AND. <var> <= <v2>,.T.,.F. ) )

#translate LTON( <var> )                => if( <var>, 1, 0 )

#xcommand DEFAULT <v1> TO <x1> [, <vn> TO <xn> ]                        ;
          =>                                                            ;
          IF <v1> == NIL ; <v1> := <x1> ; END                           ;
          [; IF <vn> == NIL ; <vn> := <xn> ; END ]

#command REPEAT => DO WHILE .T.
#command UNTIL <expr> => IF <expr>; EXIT; END; END


/*Ŀ
   STACK  
  */

#define LIFO    1
#define FIFO    2
#define NORMAL  3

/*Ŀ
   GET SYSTEM 
  */

#xcommand @ <Row>, <Col> [;
                           SAY <SayExp> [ PICTURE <SayPic>  ];
                                        [ COLOR   <SayColor>];
                         ];
                         GET <Var>   IN PAGE   <GetPage>   ;
                                   [ PICTURE   <GetPic>   ];
                                   [ WHEN      <GetWhen>  [WITH MESSAGE <WhenMsg> [IN COLOR <WhenColor> ]] ];
                                   [ VALID     <GetValid> [WITH MESSAGE <ValidMsg>[IN COLOR <ValidColor>]] ];
                                   [ COLOR     <GetColor> ];
                                   [ MENU      <GetOMenu> [SET VALUE <GetTVal>]];
                                   [ <Lock:    LOCKED>    ];
                                   [ MESSAGE   <GetMsg>   [IN COLOR <MsgColor>]];
       =>;
         <GetPage>:Add(;
                       NewGetObj(;
                                 <Row>,<Col>,<{SayExp}>,<SayPic>,<SayColor>               ,;
                                 _GET_( <Var>, <(Var)>,<GetPic>,<{GetValid}>,<{GetWhen}> ),;
                                 <GetColor>, <GetOMenu>, <GetTVal>, <.Lock.>              ,;
                                 <GetMsg>, <MsgColor>                                     ,;
                                 <WhenMsg>,<WhenColor>                                    ,;
                                 <ValidMsg>,<ValidColor>                                   ;
                                );
                      )

/*Ŀ
   TRANSACTION  
  */
# define TRS_FILE                     1
# define TRS_RECORD                   2

/*Ŀ
   EVENT 
  */

#define O_WINDOW                      1
#define O_TWINDOW                     2
#define O_MENU                        3
#define O_GET                         4
#define O_BROWSE                      5
#define O_GETLIST                     6
#define O_GETMENU                     7
#define O_SCROLL_VERTICAL             8
#define O_SCROLL_HORIZONTAL           9

#define MSG_LBUTTONDOWN               1
#define MSG_RBUTTONDOWN               2
#define MSG_LBUTTONUP                 3
#define MSG_RBUTTONUP                 4
#define MSG_MOUSEMOVE                 5
#define MSG_LRBUTTONDOWN              6
#define MSG_LRBUTTONUP                7
#define MSG_LUPRDOWN                  8
#define MSG_LDOWNRUP                  9

#define MSG_KEYBOARD                 10
#define MSG_TASK                     11
#define MSG_TIMEOUT                  12
#define MSG_QUIT                     13
#define MSG_MOVEINIT                 14
#define MSG_MOVE                     15
#define MSG_MOVEEND                  16
#define MSG_SIZEINIT                 17
#define MSG_SIZE                     18
#define MSG_SIZEEND                  19
#define MSG_MAXIMIZING               20
#define MSG_RESTORING                21
#define MSG_ENLARGING                22
#define MSG_SHRINKING                23
#define MSG_SHOW                     24
#define MSG_HIDE                     25

#define MSG_DISPLAY                 100
#define MSG_ACTIVATE                101
#define MSG_DEACTIVATE              102
#define MSG_POP                     103
#define MSG_CLOSE                   104
#define MSG_PARENTMOVE              105
#define MSG_PARENTPOP               106
#define MSG_PARENTCLOSE             107
#define MSG_DELAY                   108
#define MSG_PARENTHIDE              109
#define MSG_PARENTSHOW              110
#define MSG_MAXIMIZE                111
#define MSG_RESTORE                 112

#define MSG_SCROLL_UP               113
#define MSG_SCROLL_DOWN             114
#define MSG_SCROLL_LEFT             115
#define MSG_SCROLL_RIGHT            116
#define MSG_SCROLL_FIRST_VERT       117
#define MSG_SCROLL_LAST_VERT        118
#define MSG_SCROLL_FIRST_HORIZ      119
#define MSG_SCROLL_LAST_HORIZ       120
#define MSG_SCROLL_UP_FAST          121
#define MSG_SCROLL_DOWN_FAST        122
#define MSG_SCROLL_LEFT_FAST        123
#define MSG_SCROLL_RIGHT_FAST       124
#define MSG_REPOSITION_VERTICAL     125
#define MSG_REPOSITION_HORIZONTAL   126

#define MSG_BROWSE_REDRAW           200
#define MSG_BROWSE_MAXIMIZE         201
#define MSG_BROWSE_UPDATESONS_DISPL 202
#define MSG_BROWSE_UPDATESONS       203
#define MSG_BROWSE_FATHER           204
#define MSG_BROWSE_SON              205
#define MSG_BROWSE_BROTHER_NEXT     206
#define MSG_BROWSE_BROTHER_PREVIOUS 207

#define MSG_MENUPULLDOWN            300
#define MSG_MENUFIRST               301
#define MSG_MENULAST                302
#define MSG_MENUPREVIOUS            303
#define MSG_MENUNEXT                304
#define MSG_MENUHILITE              305
#define MSG_MENUDEHILITE            306

#define MSG_GETNEXT                 400
#define MSG_GETPREVIOUS             401
#define MSG_GETTOP                  402
#define MSG_GETBOTTOM               403
#define MSG_GETPAGEUP               404
#define MSG_GETPAGEDOWN             405

#define ENTRY_TOP                     1
#define ENTRY_LEFT                    2
#define ENTRY_BOTTOM                  3
#define ENTRY_RIGHT                   4
#define ENTRY_MESSAGE                 5

/*Ŀ
   MENU 
  */

//Code de dfinition de paramtres
//
#define MNU_SEP              "\-"
#define MNU_VERTICAL         "1"
#define MNU_HORIZONTAL       "2"
#define MNU_SYSTEM           "3"
#define MNU_VERT_BUTTON      "4"
#define MNU_HORZ_BUTTON      "5"
#define MNU_VERT_CHECKBOX    "6"
#define MNU_HORZ_CHECKBOX    "7"
#define MNU_VERT_RADIOBUTTON "8"
#define MNU_HORZ_RADIOBUTTON "9"
#define MNU_DROPDOWN_LISTBOX "A"

//Code de justification des messages
//
#define LEFTJUSTIFY   "L"
#define CENTERJUSTIFY "C"
#define RIGHTJUSTIFY  "R"

/*Ŀ
   LISTE 
  */

#define  DATA                1
#define  UP                  2
#define  DOWN                3
#define  MIDDLE1             4
#define  MIDDLE2             5
#define  EMPTY               6
#define  TEXT                7
